%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}

Name:           ganeti
Version:        2.4.0
Release:        1%{?dist}
Summary:        Cluster-based virtualization management software

Group:          System Environment/Daemons
License:        GPLv2
URL:            http://code.google.com/p/ganeti/
Source0:        http://ganeti.googlecode.com/files/ganeti-%{version}.tar.gz
Source1:        ganeti-ganeti.init
Source2:        ganeti-ganeti.sysconfig
Patch0:         ganeti-2.3.0-add_support_for_other_than_debian.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  pyOpenSSL, pyparsing, python-simplejson, python-ctypes, python-pycurl
BuildRequires:  python-paramiko, socat, python-inotify, python-devel, pylint
BuildRequires:  python-sphinx, docbook-utils, docbook-utils-pdf, graphviz, man

Requires: pyOpenSSL, pyparsing, python-simplejson, python-ctypes, python-pycurl
Requires: python-paramiko, python-inotify, openssh-clients

%description
Ganeti is a virtualization cluster management software. You are expected
to be a system administrator familiar with your Linux distribution and
the Xen or KVM virtualization environments before using it.

The various components of Ganeti all have man pages and interactive
help. This manual though will help you getting familiar with the system
by explaining the most common operations, grouped by related use.

After a terminology glossary and a section on the prerequisites needed
to use this manual, the rest of this document is divided in sections
for the different targets that a command affects: instance, nodes, etc.

%package xen
Summary:          Ganeti support for Xen
Group:            System Environment/Daemons

Requires:         %{name} = %{version}-%{release}
Requires:         xen

%description xen
Ganeti is a virtualization cluster management software. You are expected
to be a system administrator familiar with your Linux distribution and
the Xen or KVM virtualization environments before using it.

This package pulls in all required items for Xen support.

%package kvm
Summary:          Ganeti support for KVM
Group:            System Environment/Daemons

Requires:         %{name} = %{version}-%{release}
Requires:         kvm, kvm-qemu-img, kmod-kvm, socat

%description kvm
Ganeti is a virtualization cluster management software. You are expected
to be a system administrator familiar with your Linux distribution and
the Xen or KVM virtualization environments before using it.

This package pulls in all required items for KVM support.

%package drbd83
Summary:          Ganeti support for DRBD 8.3
Group:            System Environment/Daemons

Requires:         %{name} = %{version}-%{release}
Requires:         drbd83, kmod-drbd83, kmod-drbd83-xen

%description drbd83
Ganeti is a virtualization cluster management software. You are expected
to be a system administrator familiar with your Linux distribution and
the Xen or KVM virtualization environments before using it.

This package pulls in all required items for DRBD 8.3 support.

%prep
%setup -q

%patch0 -p1

%build
%configure \
  --prefix=%{_prefix} \
  --sysconfdir=%{_sysconfdir} \
  --libdir=%{_libdir} \
  --with-ssh-initscript=%{_initrddir}/sshd \
  --with-export-dir=%{_localstatedir}/lib/%{name}/export \
  --with-os-search-path=/usr/share/%{name}/os,%{_libdir}/%{name}/os,/usr/local/lib/%{name}/os,/srv/%{name}/os \
  --with-iallocator-search-path=%{_libdir}/%{name}/iallocators,/usr/local/lib/%{name}/iallocators \
  --with-xen-bootloader=/usr/bin/pygrub \
  --with-file-storage-dir=%{_localstatedir}/lib/%{name}/file-storage \
  --with-kvm-path=/usr/bin/qemu-kvm
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

install -D -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install -D -m 644 doc/examples/ganeti.default $RPM_BUILD_ROOT%{_sysconfdir}/default/%{name}
install -D -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/%{name}

# Cleanup doc
find doc -type f -exec chmod 644 "{}" \;
find doc -type d -name .dir -exec rmdir -v "{}" \;
find doc -type f -name .dir -exec rm -v "{}" \;

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add ganeti

%preun
if [ $1 = 0 ] ; then
    /sbin/chkconfig --del ganeti
    /sbin/service ganeti stop >/dev/null 2>&1
fi
exit 0

%files
%defattr(-,root,root,-)
%doc doc/*
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/default/%{name}
%{_sysconfdir}/init.d/%{name}
%{python_sitelib}/%{name}
%{_sbindir}/gnt-*
%{_sbindir}/ganeti-*
%{_libdir}/%{name}
%{_mandir}/man*/*
%dir /var/lib/%{name}
%dir /var/log/%{name}

%files xen
%defattr(-,root,root,-)

%files kvm
%defattr(-,root,root,-)

%files drbd83
%defattr(-,root,root,-)

%changelog
* Mon Mar 07 2011 Jonathan Steffan <jsteffan@fedoraproject.org> - 2.4.0-1
- Upate to 2.4.0

* Sat Feb 26 2011 Jonathan Steffan <jsteffan@fedoraproject.org> - 2.3.1-1
- Inital Build
